﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace SampleComboboxDisapearingAct
{
    public class DataItem : INotifyPropertyChanged
    {
        private List<string> mOptions;
        private string mCurrentSelectedOption;
        private string mValue;

        public DataItem()
        {
            mOptions = new List<string>();
            mOptions.Add( "One" );
            mOptions.Add( "Two" );
            mOptions.Add( "Three" );
            mCurrentSelectedOption = "One";
            OnPropertyChanged( "Value" );
            OnPropertyChanged( "CurrentSelectedOption" );
        }

        public string Name
        {
            get
            {
                return "SampleDataItemName";
            }
        }

        public string Value
        {
            get
            {
                return mValue;
            }
            private set
            {
                mValue = value;
            }
        }

        public BindingList<string> Options
        {
            get
            {
                return new BindingList<string>( mOptions );
            }
        }

        public string CurrentSelectedOption
        {
            get
            {
                return mCurrentSelectedOption;
            }
            set
            {
                if ( value != mCurrentSelectedOption && value != null )
                {
                    mCurrentSelectedOption = value;
                    mValue = value;
                    OnPropertyChanged( "Value" );
                    OnPropertyChanged( "CurrentSelectedOption" );
                }
            }
        }

        //INotification
        protected void OnPropertyChanged( PropertyChangedEventArgs e )
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if ( handler != null )
                handler( this, e );
        }
        
        protected void OnPropertyChanged( string propertyName )
        {
            OnPropertyChanged( new PropertyChangedEventArgs( propertyName ) );
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}
